'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _DocHelpers = require('../mixins/DocHelpers');

var _DocHelpers2 = _interopRequireDefault(_DocHelpers);

var _ReactDocSection = require('./ReactDocSection');

var _ReactDocSection2 = _interopRequireDefault(_ReactDocSection);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PropTypes = _react2.default.PropTypes;

var ReactDocMain = _react2.default.createClass({
  displayName: 'ReactDocMain',

  propTypes: {
    reactDocJson: PropTypes.object,
    previewConfig: PropTypes.object,
    params: PropTypes.object.isRequired,
    grouper: PropTypes.func
  },

  mixins: [_DocHelpers2.default],

  renderDocMain: function renderDocMain() {

    var props = this.props;

    return _react2.default.createElement(
      'main',
      { elem: 'doc-main' },
      (0, _lodash2.default)(props.reactDocJson).values().filter(function (componentItem) {
        if (props.params.groupName) {
          if (props.params.componentName) {
            return props.grouper(componentItem.module) === props.params.groupName && componentItem.name === props.params.componentName;
          }
          return props.grouper(componentItem.module) === props.params.groupName;
        }
        return true;
      }).map(function (componentItem, idx) {
        return _react2.default.createElement(_ReactDocSection2.default, {
          key: idx,
          componentItem: componentItem,
          previewConfig: props.previewConfig
        });
      }).value()
    );
  },
  render: function render() {
    return _react2.default.createElement(
      'div',
      { className: 'react-doc-main' },
      this.renderDocMain()
    );
  }
});

exports.default = ReactDocMain;