'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _DocHelpers = require('../mixins/DocHelpers');

var _DocHelpers2 = _interopRequireDefault(_DocHelpers);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PropTypes = _react2.default.PropTypes;

var ReactDocMenu = _react2.default.createClass({
  displayName: 'ReactDocMenu',

  propTypes: {
    reactDocJson: PropTypes.object,
    /**
     * `groupName`, `componentName`
     */
    onItemClick: PropTypes.func,
    grouper: PropTypes.func
  },

  mixins: [_DocHelpers2.default],

  getDefaultProps: function getDefaultProps() {
    return {
      onItemClick: function onItemClick() {
        return null;
      }
    };
  },
  _getGroups: function _getGroups(info) {
    var _this = this;

    return (0, _lodash2.default)(info).values().map(function (componentItem) {
      return _this.props.grouper(componentItem.module);
    }).uniq().value();
  },
  _onItemClick: function _onItemClick(groupName, componentName, evt) {
    evt.preventDefault();
    this.props.onItemClick(groupName, componentName);
  },
  renderMenuItem: function renderMenuItem(componentList) {
    var _this2 = this;

    return _lodash2.default.map(componentList, function (componentItem, idx) {
      return _react2.default.createElement(
        'li',
        { className: 'react-doc-menu__group-list-item',
          key: idx },
        _react2.default.createElement(
          'a',
          { href: '#',
            onClick: _this2._onItemClick.bind(_this2, _this2.props.grouper(componentItem.module), componentItem.name) },
          componentItem.name
        )
      );
    });
  },
  renderWrapper: function renderWrapper(children) {
    return _react2.default.createElement(
      'div',
      { className: 'react-doc-menu' },
      _react2.default.createElement(
        'h1',
        { className: 'react-doc-menu__group-heading' },
        _react2.default.createElement(
          'a',
          { href: '#',
            onClick: this._onItemClick.bind(this, null, null) },
          'All'
        )
      ),
      children
    );
  },
  render: function render() {
    var _this3 = this;

    var groups = this._getGroups(this.props.reactDocJson);

    if (!_lodash2.default.isEmpty(groups)) {
      return this.renderWrapper(_lodash2.default.map(groups, function (groupName, idx) {
        return _react2.default.createElement(
          'div',
          {
            key: idx,
            className: 'react-doc-menu__group' },
          _react2.default.createElement(
            'h1',
            { className: 'react-doc-menu__group-heading' },
            _react2.default.createElement(
              'a',
              { href: '#',
                onClick: _this3._onItemClick.bind(_this3, groupName, null) },
              groupName
            )
          ),
          _react2.default.createElement(
            'ul',
            { className: 'react-doc-menu__group-list' },
            _this3.renderMenuItem((0, _lodash2.default)(_this3.props.reactDocJson).values().filter(function (componentItem) {
              return _this3.props.grouper(componentItem.module) === groupName;
            }).value())
          )
        );
      }));
    }

    return this.renderWrapper(this.renderMenuItem(_lodash2.default.values(this.props.reactDocJson)));
  }
});

exports.default = ReactDocMenu;