'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _browser = require('babel-core/lib/api/browser');

var babel = _interopRequireWildcard(_browser);

var _babelPresetEs = require('babel-preset-es2015');

var _babelPresetEs2 = _interopRequireDefault(_babelPresetEs);

var _babelPresetStage = require('babel-preset-stage-0');

var _babelPresetStage2 = _interopRequireDefault(_babelPresetStage);

var _babelPresetReact = require('babel-preset-react');

var _babelPresetReact2 = _interopRequireDefault(_babelPresetReact);

var _CodeMirrorEditor = require('./CodeMirrorEditor');

var _CodeMirrorEditor2 = _interopRequireDefault(_CodeMirrorEditor);

var _ReactPreview = require('./ReactPreview');

var _ReactPreview2 = _interopRequireDefault(_ReactPreview);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PropTypes = _react2.default.PropTypes;

var ReactPlayground = (function (_React$Component) {
  (0, _inherits3.default)(ReactPlayground, _React$Component);

  function ReactPlayground(props) {
    (0, _classCallCheck3.default)(this, ReactPlayground);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(ReactPlayground).call(this, props));

    _this.state = {
      codeText: props.codeText,
      showCode: false
    };
    return _this;
  }

  (0, _createClass3.default)(ReactPlayground, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.executeCode();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _this2 = this;

      if (this.state.codeText !== nextProps.codeText) {
        this.setState({
          codeText: nextProps.codeText
        }, function () {
          _this2.executeCode();
        });
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      clearTimeout(this.timeoutID);
    }
  }, {
    key: 'setTimeout',
    value: (function (_setTimeout) {
      function setTimeout() {
        return _setTimeout.apply(this, arguments);
      }

      setTimeout.toString = function () {
        return _setTimeout.toString();
      };

      return setTimeout;
    })(function () {
      clearTimeout(this.timeoutID);
      this.timeoutID = setTimeout.apply(null, arguments);
    })
  }, {
    key: 'executeCode',
    value: function executeCode() {

      try {

        var compiledCodeText = babel.transform(this.state.codeText, {
          sourceMaps: 'inline',
          presets: [_babelPresetEs2.default, _babelPresetStage2.default, _babelPresetReact2.default]
        }).code;

        if (compiledCodeText) {
          this.setState({
            compiledCodeText: compiledCodeText
          });
        }
      } catch (err) {
        this.setTimeout(function () {
          console.error(err);
        }, 500);
      }
    }
  }, {
    key: '_onCodeToggle',
    value: function _onCodeToggle(evt) {
      evt.preventDefault();
      this.setState({
        showCode: !this.state.showCode
      });
    }
  }, {
    key: 'handleCodeChange',
    value: function handleCodeChange(value) {
      this.setState({ codeText: value });
      this.executeCode();
    }
  }, {
    key: 'renderPreview',
    value: function renderPreview(component) {
      return component;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({}, this.props, {
          className: 'react-playground' }),
        _react2.default.createElement(
          'div',
          { className: 'react-playground__example' },
          _react2.default.createElement(
            'div',
            { className: 'react-playground__example-inner' },
            _react2.default.createElement(_ReactPreview2.default, {
              previewConfig: this.props.previewConfig,
              codeString: this.state.compiledCodeText })
          )
        ),
        this.state.showCode ? _react2.default.createElement(_CodeMirrorEditor2.default, {
          key: 'jsx',
          onChange: function onChange(e) {
            return _this3.handleCodeChange(e);
          },
          codeText: this.state.codeText }) : null,
        _react2.default.createElement(
          'a',
          { href: '#',
            onClick: function onClick(e) {
              return _this3._onCodeToggle(e);
            },
            className: (0, _classnames2.default)('react-playground__code-toggle', {
              'react-playground__code-toggle--open': this.state.showCode
            })
          },
          this.state.showCode ? 'hide code' : 'show code'
        )
      );
    }
  }]);
  return ReactPlayground;
})(_react2.default.Component);

ReactPlayground.propTypes = {
  codeText: PropTypes.string.isRequired,
  previewConfig: PropTypes.object
};
exports.default = ReactPlayground;