'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _Resizable = require('./Resizable');

var _Resizable2 = _interopRequireDefault(_Resizable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PropTypes = _react2.default.PropTypes;

var ReactPreview = (function (_React$Component) {
  (0, _inherits3.default)(ReactPreview, _React$Component);

  function ReactPreview(props) {
    (0, _classCallCheck3.default)(this, ReactPreview);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(ReactPreview).call(this, props));

    _this.state = {
      width: 320,
      height: 500
    };
    return _this;
  }

  (0, _createClass3.default)(ReactPreview, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.refreshIframe(this.props);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.codeString !== this.props.codeString) {
        this.refreshIframe(nextProps);
      }
    }
  }, {
    key: 'refreshIframe',
    value: function refreshIframe(props) {

      var iframe = _reactDom2.default.findDOMNode(this.refs.iframe);

      if (iframe) {
        (function () {

          var iframeDoc = iframe.contentDocument || iframe.contentWindow.document;

          iframeDoc.close();

          var styles = props.previewConfig.styles || [];
          var scripts = props.previewConfig.scripts || [];

          var headBlocks = [];
          var codeBlocks = [];

          styles.forEach(function (link) {
            headBlocks.push('<link rel=\'stylesheet\' href=\'' + link + '\'/> ');
          });

          scripts.forEach(function (link) {
            codeBlocks.push('<script src=\'' + link + '\'></script>');
          });

          var script = '\n        (function() {\n          var __components__ = ' + (props.previewConfig.components || 'components') + ';\n          function defaultRequire(path) {\n            return __components__[path].default || __components__[path];\n          }\n          (function(require, module, exports) {\n            var React = require(\'react\');\n            var ReactDOM = require(\'react-dom\');\n            ' + props.codeString + '\n            ReactDOM.render(React.createElement(exports.default || module.exports, {}, null), document.getElementById(\'root\'))\n          })(defaultRequire, {}, {});\n        })();\n      ';

          codeBlocks.push('<script>' + script + '</script>');

          iframeDoc.open();
          iframeDoc.write('\n      <html>\n        <head>' + headBlocks.join('\n') + '</head>\n        <body>\n          <div id=\'root\'></div>\n          ' + codeBlocks.join('\n') + '\n        </body>\n      </html>');
        })();
      }
    }
  }, {
    key: 'onResize',
    value: function onResize(evt, _ref) {
      var size = _ref.size;

      this.setState(size);
    }
  }, {
    key: 'resizeWidth',
    value: function resizeWidth(evt) {
      this.setState({
        width: parseInt(evt.target.value)
      });
    }
  }, {
    key: 'resizeHeight',
    value: function resizeHeight(evt) {
      this.setState({
        height: parseInt(evt.target.value)
      });
    }
  }, {
    key: 'render',
    value: function render() {

      var state = this.state;

      var styles = {
        width: state.width + 'px', height: state.height + 'px'
      };

      return _react2.default.createElement(
        'div',
        { className: 'react-preview' },
        _react2.default.createElement(
          'div',
          { className: 'react-preview__size-input' },
          _react2.default.createElement(
            'label',
            null,
            _react2.default.createElement(
              'span',
              null,
              ' width:'
            ),
            _react2.default.createElement('input', { name: 'width',
              type: 'number',
              value: state.width,
              onChange: this.resizeWidth.bind(this) })
          ),
          _react2.default.createElement(
            'label',
            null,
            _react2.default.createElement(
              'span',
              null,
              ' height:'
            ),
            _react2.default.createElement('input', { name: 'height',
              type: 'number',
              value: state.height,
              onChange: this.resizeHeight.bind(this) })
          )
        ),
        _react2.default.createElement(
          _Resizable2.default,
          {
            width: state.width,
            height: state.height,
            className: 'react-preview__resize--container',
            onResize: this.onResize.bind(this) },
          _react2.default.createElement('iframe', { ref: 'iframe',
            style: styles })
        )
      );
    }
  }]);
  return ReactPreview;
})(_react2.default.Component);

ReactPreview.propTypes = {
  codeString: PropTypes.string,
  previewConfig: PropTypes.object
};
ReactPreview.defaultProps = {
  previewConfig: {}
};
exports.default = ReactPreview;