'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _reactResizable = require('react-resizable');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Resizable = (function (_React$Component) {
  (0, _inherits3.default)(Resizable, _React$Component);

  function Resizable(props) {
    (0, _classCallCheck3.default)(this, Resizable);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Resizable).call(this, props));

    _this.state = {
      width: props.width,
      height: props.height
    };
    return _this;
  }

  (0, _createClass3.default)(Resizable, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.width !== this.state.width || nextProps.height !== this.state.height) {
        this.setState({
          width: nextProps.width,
          height: nextProps.height
        });
      }
    }
  }, {
    key: 'onResize',
    value: function onResize(evt, _ref) {
      var size = _ref.size;

      this.setState(size);
      this.props.onResize(evt, {
        size: size
      });
    }
  }, {
    key: 'onResizeStop',
    value: function onResizeStop() {
      _reactDom2.default.findDOMNode(this.refs.mask).classList.remove('show');
    }
  }, {
    key: 'onResizeStart',
    value: function onResizeStart() {
      _reactDom2.default.findDOMNode(this.refs.mask).classList.add('show');
    }
  }, {
    key: 'render',
    value: function render() {
      var props = this.props;
      var state = this.state;

      var styles = {
        width: state.width + 'px', height: state.height + 'px'
      };

      return _react2.default.createElement(
        _reactResizable.Resizable,
        {
          width: props.width,
          height: props.height,
          className: props.className,
          minConstraints: [320, 320],
          onResizeStop: this.onResizeStop.bind(this),
          onResizeStart: this.onResizeStart.bind(this),
          onResize: this.onResize.bind(this) },
        _react2.default.createElement(
          'div',
          { style: styles },
          props.children,
          _react2.default.createElement('div', { ref: 'mask',
            className: 'react-resizable__mask' })
        )
      );
    }
  }]);
  return Resizable;
})(_react2.default.Component);

Resizable.propTypes = {
  width: _react.PropTypes.number,
  height: _react.PropTypes.number,
  onResize: _react.PropTypes.func
};
Resizable.defaultProps = {
  onResize: function onResize() {
    return null;
  }
};
exports.default = Resizable;