'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _gulpUtil = require('gulp-util');

var _gulpUtil2 = _interopRequireDefault(_gulpUtil);

var _through = require('through2');

var _through2 = _interopRequireDefault(_through);

var _reactDocgen = require('react-docgen');

var reactDocGen = _interopRequireWildcard(_reactDocgen);

var _getModulePathByVinylFile = require('./libs/getModulePathByVinylFile');

var _getModulePathByVinylFile2 = _interopRequireDefault(_getModulePathByVinylFile);

var _getModuleInfoByVinylFile = require('./libs/getModuleInfoByVinylFile');

var _getModuleInfoByVinylFile2 = _interopRequireDefault(_getModuleInfoByVinylFile);

var _descriptionProcess = require('./libs/descriptionProcess');

var _descriptionProcess2 = _interopRequireDefault(_descriptionProcess);

var _getDocDependenceListByResult = require('./libs/getDocDependenceListByResult');

var _getDocDependenceListByResult2 = _interopRequireDefault(_getDocDependenceListByResult);

var _generateDocDependenceListByRequireList = require('./libs/generateDocDependenceListByRequireList');

var _generateDocDependenceListByRequireList2 = _interopRequireDefault(_generateDocDependenceListByRequireList);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PLUGIN_NAME = 'react-doc';

function gulpPlugin() {
  var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var result = {};

  function docJson(file, enc, cb) {

    file.cwd = options.cwd;

    try {

      var moduleInfo = reactDocGen.parse(String(file.contents));

      if (!_lodash2.default.isEmpty(moduleInfo)) {
        result[(0, _getModulePathByVinylFile2.default)(file)] = _lodash2.default.merge((0, _descriptionProcess2.default)(moduleInfo, _lodash2.default.merge({}, options, {
          basedir: _path2.default.dirname(file.path)
        })), (0, _getModuleInfoByVinylFile2.default)(file));
      }
    } catch (err) {
      this.emit('error', new _gulpUtil2.default.PluginError(PLUGIN_NAME, err));
    }

    return cb();
  }

  function endStream(cb) {

    var filename = options.filename || PLUGIN_NAME;

    var jsonFile = new _gulpUtil2.default.File({
      path: filename + '.json',
      contents: new Buffer((0, _stringify2.default)(result, null, 2))
    });

    var requireListFile = new _gulpUtil2.default.File({
      path: filename + '.js',
      contents: new Buffer((0, _generateDocDependenceListByRequireList2.default)((0, _getDocDependenceListByResult2.default)(result)))
    });

    this.push(jsonFile);
    this.push(requireListFile);

    cb();
  }

  return _through2.default.obj(docJson, endStream);
}

exports.default = gulpPlugin;