'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _marked = require('marked');

var _marked2 = _interopRequireDefault(_marked);

var _descriptionExtract = require('./descriptionExtract');

var _descriptionExtract2 = _interopRequireDefault(_descriptionExtract);

var _getExampleContents = require('./getExampleContents');

var _getExampleContents2 = _interopRequireDefault(_getExampleContents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function defaultDescriptionCompiler(string) {
  return (0, _marked2.default)(string);
}

function descriptionProcess() {
  var targetObj = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
  var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var descObj = (0, _descriptionExtract2.default)(targetObj.description);

  if (descObj) {

    var descriptionCompiler = _lodash2.default.isFunction(options.descriptionCompiler) ? options.descriptionCompiler : defaultDescriptionCompiler;

    descObj = {
      description: descriptionCompiler(descObj.description),
      examples: pickExampleFromTags(descObj.tags, options)
    };

    if (_lodash2.default.isObject(targetObj.props)) {
      _lodash2.default.forEach(_lodash2.default.keys(targetObj.props), function (key) {
        targetObj.props[key] = descriptionProcess(targetObj.props[key], options);
      });
    }

    return _lodash2.default.merge({}, targetObj, descObj);
  }

  return targetObj;
}

function pickExampleFromTags() {
  var tags = arguments.length <= 0 || arguments[0] === undefined ? [] : arguments[0];
  var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  return _lodash2.default.reduce(tags, function (exampleList, tagItem) {
    return exampleList.concat((0, _getExampleContents2.default)(tagItem, options));
  }, []);
}

exports.default = descriptionProcess;